--load 3DreamEngine
dream = require("3DreamEngine")
collision = require("3DreamEngine/collision")
world = require("lib/essence/modules/world")
basefuncs = require("lib/essence/modules/basefuncs")

--optionally set settings
dream:setBloom(3)
dream:setDither(false);

--inits (applies settings)
dream:setNameDecoder()
dream:init()

--loads a object
models = "objects/models"


-- Audio
--sandCastleAmbience = love.audio.newSource("lib/essence/sounds/sand_castle.mp3", "stream")
--love.audio.play(sandCastleAmbience)

--creates a light
light = dream:newLight("point", 1, 2, 3, 1.0, 0.75, 0.2)

--add shadow
light:addShadow()


---
updateTimer = 0
dt = 1/60

--Plr
local player = {
  x = 0,
  y = 0,
  z = 5,
  ax = 0,
  ay = 0,
  az = 0,
}
dream.cam.rx = 0
dream.cam.ry = math.pi/4

--Phys load
collModel = world.newModel("ground")

-- model test
curModel = world.newModel("wallwindow")
local curPos = vec3()


--# Variables
local renderHit = false
local gridSize = 1


---# Update
function essencedraw()
  if leveleditor==true then
  --update camera
  dream.cam:reset()
  dream.cam:translate(-player.x, -player.y, -player.z)
  dream.cam:rotateY(dream.cam.ry)
  dream.cam:rotateX(dream.cam.rx)
  
  dream:prepare()

  --reset lighting to default sun
  dream:resetLight()

  --add light
  dream:addLight(light)  

  --rotate, draw and offset
  --dream:draw(collModel.object, 0, 0, 0)

  --mouse world position
  local playerPos = vec3(player.x, player.y, player.z)
  local segment
  local x, y = love.mouse.getPosition()
  local point = vec3(0, 0, 0)
  if renderHit then
    point = dream:pixelToPoint(vec3(x, y, 30))
    segment = collision:newSegment(playerPos, point)
  end
  point = point or vec3(0, 0, 0)

  --segment collision
  local normal, position = nil, nil
  local lastPos = point
  local lastNorm = nil

  if segment then
  	for _, collisionModel in pairs(world.scene) do
  		if collisionModel ~= curModel then
  			normal, position = collision:collide(segment, collisionModel.collider)
  			if normal and position then 
  				if (position - vec3(player.x, player.y, player.z)):length() < (lastPos - vec3(player.x, player.y, player.z)):length() then
  					lastPos = position
  					lastNorm = normal
  				end
  			end
  		end
  	end
  end
  curModel.position = point
  position = lastPos
  normal = lastNorm

  -- set offset position
  if normal then
  	local offset
    if normal.x ~= 0 then offset = vec3((normal.x*curModel.size.x)/2, 0, 0) end
    if normal.y ~= 0 then offset = vec3(0, (normal.y*curModel.size.y)/2, 0) end
    if normal.z ~= 0 then offset = vec3(0, 0, (normal.z*curModel.size.z)/2) end
    curModel.position = position + offset
  end
  curModel = world.updateModelPos(curModel, basefuncs.snapToGrid(curModel.position))
  curPos = basefuncs.lerpVec3(curPos, curModel.position, (2*dt))
  --dream:draw(curModel.object, curModel.position.x, curModel.position.y, curModel.position.z)

  -- Render Everything
  for _, model in pairs(world.scene) do
  	local renderPos = model.position
  	if model == curModel then renderPos = curPos end
  	dream:draw(model.object, renderPos.x, renderPos.y, renderPos.z)
  end


  --render
  dream:present()
  end
end

function essenceupdate()
if leveleditor==true then
  --update timer
  updateTimer = updateTimer + dt

  --camera
  local d = love.keyboard.isDown
  local speed = 3*dt
  love.mouse.setRelativeMode(false)
  
  --collision
  player.x = player.x + player.ax * dt
  player.y = player.y + player.ay * dt
  player.z = player.z + player.az * dt
  
  if d("w") then
    player.ax = player.ax + math.cos(-dream.cam.ry-math.pi/2) * speed
    player.az = player.az + math.sin(-dream.cam.ry-math.pi/2) * speed
  end
  if d("s") then
    player.ax = player.ax + math.cos(-dream.cam.ry+math.pi-math.pi/2) * speed
    player.az = player.az + math.sin(-dream.cam.ry+math.pi-math.pi/2) * speed
  end
  if d("a") then
    player.ax = player.ax + math.cos(-dream.cam.ry-math.pi/2-math.pi/2) * speed
    player.az = player.az + math.sin(-dream.cam.ry-math.pi/2-math.pi/2) * speed
  end
  if d("d") then
    player.ax = player.ax + math.cos(-dream.cam.ry+math.pi/2-math.pi/2) * speed
    player.az = player.az + math.sin(-dream.cam.ry+math.pi/2-math.pi/2) * speed
  end
  if d("space") then
    player.ay = player.ay + speed
  end
  if d("lshift") then
    player.ay = player.ay - speed
  end
  --if d("e") and leveleditor==true then leveleditor=false createcanvas() end
  
  --air resistance
  player.ax = player.ax * (1 - dt*2)
  player.ay = player.ay * (1 - dt*2)
  player.az = player.az * (1 - dt*2)
  
  --mount cam
  dream.cam.x = player.x
  dream.cam.y = player.y+0.3
  dream.cam.z = player.z

  --update
  dream:update()
  end
end

function love.mousemoved(_, _, x, y)
local mx, my = love.mouse.getPosition()
  if love.mouse.isDown(2) == true then
    local speedH = 0.005
    local speedV = 0.005
    dream.cam.ry = dream.cam.ry - x * speedH
    dream.cam.rx = math.max(-math.pi/2, math.min(math.pi/2, dream.cam.rx + y * speedV))

    --[[if lockPos == nil then lockPos = vec2( love.mouse.getX(), love.mouse.getY() ) end
    love.mouse.setPosition( lockPos.x, lockPos.y )]]
   --[[else
   	lockPos = nil]]
  end
 
end

function love.mousepressed(x, y, button, istouch)
   if button == 1 then
      curModel = world.newModel("wallwindow", nil, curModel.rotation)
   end
end


function love.keypressed(key)
  if key == "e" then
  leveleditor=false
  end
  
  if key == "q" then
    renderHit = true
  end
  if key == "r" and renderHit == true and curModel then
    curModel = world.rotateModel(curModel, 90)
  end
end
