
local Terminal = require "terminal"
local moonshine = require 'moonshine'
--lua.sh
sh = require('sh')
local runvr=sh.command('qterminal -e ./runvr')
effect = moonshine(moonshine.effects.scanlines).chain(moonshine.effects.crt).chain(moonshine.effects.glow).chain(moonshine.effects.filmgrain)
effect.scanlines.opacity=0.6
effect.glow.min_luma = 0.2

effect.filmgrain.size=1.5
effect.filmgrain.opacity=2
--effect.godsray.samples=3
local font = love.graphics.newFont("x14y24pxHeadUpDaisy.ttf", 24) -- Thanks @hicchicc for the font
local term = Terminal(14*80, (font:getHeight()-4)*25, font, nil, font:getHeight()-4)
term:hide_cursor()
local cursorx=41
local selection="yes"

term:set_cursor_color(Terminal.schemes.basic[4])
term:frame("line", 1,1,80,25)

term:set_cursor_color(Terminal.schemes.basic[3])
term:blit(3,2,
[[ ___      __   __         __
 .0kxxxxxxxxxxxxxxxxxxxOk.          
 ;M.                   xN0O'        
 ;M.                   xK ,O0;      
 ;M.                   xK   .kK:    
 ;M.                   xX.....:KXc  
 ;M.        .          ;olllllxllXk 
 ;M.                             OO 
 ;M..KNl. .OMo        .NX:  :KW, OO 		--------------------------------
 ;M.  cXWKMO'           oNNNWx.  OO 		Lovr is not found!  
 ;M.  ;0MXMk.           cXNNNo.  OO 		--------------------------------
 ;M..KWd. ,0Md        .NNl  :XWc OO 
 ;M.  .     .          .      .  OO 		you need it to play lovr games
 ;M.                             OO 
 ;M. ..........................  OO 
 ;M..OOOKMX0MNOWMOOOOOOOOOOOOOOd OO 
 ;M.     XK.MO'Mx                OO 
 ;M.     .KNMWWx                 OO 
 ;M.       .,'                   OO 
 ;M.                             OO 
 'Kkxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0o 
]])

term:set_cursor_color(Terminal.schemes.basic[7])
term:print(41, 16, "do you wish to download lovr now?")

term:set_cursor_color(Terminal.schemes.basic[6])
--term:reverse_cursor(45, 16,"fff")
term:print(cursorx, 18, "☛ ")
term:print(43, 18, "Yes /  No")

function love.keypressed(key) 

	if key=="q" then os.exit() 
		elseif key == 'left' then term:print(48, 18, " ")
			cursorx=41 term:print(cursorx, 18, "☛ ")
			selection="yes"
		elseif key == 'right' then term:print(41, 18, " ")
			cursorx=48 term:print(cursorx, 18, "☛ ")
			selection="no"
		elseif key=="y" then 
		elseif key=="n" then
		elseif key=="return" and selection=="yes" then runvr()
		elseif key=="return" and selection=="no" then os.exit()
	end
end


--term:print(4, 12, "Features")
--term:print(4, 14, "☛ Unicode support")
--term:print(4, 15, "☛ Slow terminal emulation")
--term:print(4, 16, "☛ Helpers")
--term:print(4, 16, "☛ Settings (speed, dimensions, font, ...)")

--term:print(4, 17, "☛ ")
--local text_line = "2 colors per character !"
--for i=1,#text_line do
    --term:set_cursor_color(Terminal.schemes.basic[i%8])
    --term:set_cursor_backcolor(Terminal.schemes.basic[(i+6)%8])
    --term:print(text_line:sub(i, i))
--end

--term:set_cursor_color(Terminal.schemes.basic[6])
--term:set_cursor_backcolor(Terminal.schemes.basic[0])
--term:reverse_cursor(true)
--term:print(4, 18, "☛ Reversed color mode")

--term:reverse_cursor()
--term:print(4, 22, "Shaders courtesy of the Moonshine library.")
--term:print(4, 23, "x14y24HeadUpDaisy font by @hicchicc.")

function love.update(dt)
    term:update(dt)
end

function love.draw()
    love.graphics.clear()
    effect(function()
        love.graphics.push()
        love.graphics.scale(love.graphics.getWidth()/term.canvas:getWidth(), love.graphics.getHeight()/term.canvas:getHeight())
        love.graphics.rectangle("fill", 0,0,term.canvas:getWidth(), term.canvas:getHeight())
        term:draw()
        love.graphics.pop()
    end)
end
