local modules = (...):gsub('%.[^%.]+$', '') .. '.'
local base_node = require(modules .. 'base_node')

local multi = base_node:extend('multi')

function multi:constructor()
	multi.super.constructor(self)
	self.index = self.index or 1
	self.items = self.items or {}
	self.text = self.items[self.index]
end

function multi:change()
	self.index = self.index + 1
	if self.index > #self.items then self.index = 1 end
	self.text = self.items[self.index]
end

function multi:setIndex(index)
	if index > 0 and index <= #self.items then
		self.index = index
		self.text = self.items[self.index]
	end
end

function multi:setValue(text)
	local index = 1
	for i = 1, #self.items do
		index = i
		if self.items[i] == text then break end
	end

	self.index = index
	self.text = self.items[self.index]
end

return multi